stages:
  - build_jre
  - build_image
  - deploy

build_jre:
  stage: build_jre
  image: maven:3.8.5-openjdk-17-slim
  script:
    - mvn clean package
  artifacts:
    paths:
      - target/*.jar
      - target/log4j.properties

build_image:
  stage: build_image
  image:
    name: gcr.io/kaniko-project/executor:v1.9.0-debug
    entrypoint: [ "" ]
  script:
    - echo -n "$DOCKER_CONFIG_JSON_BASE64" | base64 -d > /kaniko/.docker/config.json
    - /kaniko/executor
      --context "."
      --dockerfile "Dockerfile"
      --destination "kudze/kursinis-device-connector-stream:${CI_COMMIT_SHA}"

deploy:
  stage: deploy
  image:
    name: bitnami/kubectl:latest
    entrypoint: [ '' ]
  script:
    - kubectl config use-context kudzecodes/kudze-presentation:my-local
    - echo -n "$KAFKA_TRUSTSTORE_PKCS12_BASE64" | base64 --decode > deployments/staging/truststore.p12
    - sed -i "s/\$CI_COMMIT_SHA/$CI_COMMIT_SHA/g" deployments/staging/kustomization.yaml
    - sed -i "s/\$KAFKA_TRUSTSTORE_PASSWORD/$KAFKA_TRUSTSTORE_PASSWORD/g" deployments/staging/DeployStream.yml
    - kubectl apply -k deployments/staging